#ifndef CONFIGURATION_FILE_H
#define CONFIGURATION_FILE_H

#include "mbed.h"
#include "ConfigFile.h"
#include "ConfigurationFile.h"
#include <string>

class ConfigurationFile{
    public:
        ConfigurationFile();
        ~ConfigurationFile();
        
        string getIP();
        string getMask();
        string getGateway();
        string getURL();
        int getBroadcastPort();
        
        void getUnitConfiguration();
        
    private:
        ConfigFile cfg;
        
        string ip;
        string mask;
        string gateway;
        string broadcastPort; 
        string url;
        
        void setIP();
        void setMask();
        void setGateway();
        void setURL();
        void setBroadcastPort();
        
        void readUnitConfiguration();
        void readConfigurationFile(char *pathName);
};

#endif